;; GAME TEMPLATES

;player groups and alliances
(def *no-one 'group-no-one) ;no one
(def *self 'group-self)     ;one's self
(def *allies 'group-allies) ;one's allies
(def *enemies 'group-enemies);one's enemies
(def *everyone 'group-everyone) ;everyone
(def *inherit 'group-inherit)   ;default


(defn create-zonetype [name visibility]
  (list 'zone-type name visibility)
)

(defn create-quantity [name initial-value]
  (list 'quantity name initial-value)
)


(defn gametype-mtg[]
  {
   :zone-types
   (list
    (create-zonetype 'library *no-one)
    (create-zonetype 'graveyard *everyone)
    (create-zonetype 'out-of-play *inherit)
    (create-zonetype 'batlefield *inherit)
    (create-zonetype 'hand *self)
  )
  :player-quantities (list
    (create-quantity 'life 20)
    (create-quantity 'red-mana 0)
    (create-quantity 'blue-mana 0)
    (create-quantity 'green-mana 0)
    (create-quantity 'white-mana 0)
    (create-quantity 'black-mana 0)
    (create-quantity 'colorless-mana 0)
  )

   :fn-add-player (fn[player-name & teammates]
     (list 'player player-name)
   )
  }
  
)


;; GAME INSTANCES
(defn add-player[game player-name & teammates]
     (apply (game :gametype :fn-add-player) (cons player-name teammates))
)

(defn new-game [gametype]
  {
   :gametype (gametype)
   :players (ref '())
   :allies  (ref '()) ;list of (player-1 player-2 relationship). transitive.
  }
)

