(ns rlm.rlm-commands
  (:use rlm.ns-rlm)
  (:require clojure.java.javadoc))

;; (defn current-directory [] (ds/file-str "/home/r/mobius"))

;; (defn file-re [regex & {:keys [dir recurse] :or
;; 			{dir (current-directory) recurse false}}]
;;   (let [dir (ds/file-str dir)]
;;     (filter (fn [file] (re-matches regex (.getName file)))
;; 	    (if recurse
;; 	      (file-seq dir)
;; 	      (seq (.listFiles dir))))))

(defmacro undef
  "removes symbol from the current namespace"
  [& symbols]
  `(dorun (map (partial ns-unmap *ns*) (quote ~symbols))))

(defn ns-reset-fn
  "unmaps all interned symbols from the current namespace (except in-ns and ns)"
  ([ns-name]
     (map (fn [s] (ns-unmap ns-name s))
	  (keys (ns-interns ns-name)))))

(defmacro ns-reset
  "unmaps all symbols from the current namespace (except in-ns and ns)"
  ([ns-name] `(ns-clear-fn (quote ~ns-name)))
  ([] `(ns-clear-fn (quote ~(symbol (str *ns*))))))

(defmacro ns-nuke-old
  ([]
     (let [current-ns# (symbol (str *ns*))]
       `(do 
	  (println "NUKING namespace" (quote ~current-ns#))
	  (clojure.lang.Namespace/remove  (quote ~current-ns#))
	  (ns ~current-ns#)))))

(defmacro ns-nuke
  "Removes all symbols and all referenced symbols. Use as a last
   resort."
  ([]
     (let [current-ns# (symbol (str *ns*))]
       `(ns-nuke ~current-ns#)))
  ([ns]
     `(do
	(println "NUKING namespace" (quote ~ns))
	(clojure.lang.Namespace/remove  (quote ~ns))
	(ns ~ns))))

(defmacro reload []
  `(do
     (rlm.rlm-commands/ns-nuke)
     (clojure.core/use
      :reload-all
      (clojure.core/symbol (clojure.core/str clojure.core/*ns*)))))

(defmacro re "faster"
  []
  `(do
     (rlm.rlm-commands/ns-nuke)
     (clojure.core/use :reload
      (clojure.core/symbol (clojure.core/str clojure.core/*ns*)))))

;; (defn keymap-clojure []
;;   (rlm.shell-write/sw "xmodmap" "/home/r/.xmodmap.clojure"))

;; (defn keymap-normal []
;;   (rlm.shell-write/sw "xmodmap" "/home/r/.xmodmap.normal"))

(defn javadoc [target]
  (binding
      [clojure.java.browse/*open-url-script*
       "/home/r/proj/repl/get-webpage.pl"]
    (clojure.java.javadoc/javadoc target)))
     
(defn help
  "load a bunch of really useful help functions"
  []
  (use
   '[rlm
     [function-utils :only [race race-pred defmix]]
     [rlm-commands :only
      [undef ns-reset ns-nuke reload re javadoc]]
     [ns-rlm :only [ls]]
     ;;[play-all :only [play-all-music]]
     [shell-inspect :only [command-line?]]
     ;;[shell-write :only [sw]]
     ;;[classpath-utils :only [classpath add-to-classpath]]
     [dreams :only [megadef silence]]
     [map-utils :only [map-keys filter-keys filter-vals]]
     [visualize :only [visual]]
     [identify :only [identify]]]

   ;;'[abomination.no-parens :only [quit]]
   
   ;; TODO find replacement for show
    '[clojure
      [repl :only [source]]])
  (clojure.java.javadoc/add-local-javadoc
   "/home/r/proj/jMonkeyEngine3/dist/javadoc")
  (clojure.java.javadoc/add-local-javadoc
   "/home/r/java/jdk6u30-docs/api")
  (clojure.java.javadoc/add-local-javadoc
   "/home/r/java/jdk6u30-docs/jdk/api")
  (clojure.java.javadoc/add-local-javadoc
   "/home/r/java/jdk6u30-docs/jre/api")
  (clojure.java.javadoc/add-local-javadoc
   "/home/r/proj/jmeCapture/docs")
  (clojure.java.javadoc/add-local-javadoc
   "/home/r/java/tritonus.sourceforge.net/apidoc")
  nil)

 

